module CVE
  class Filter
    def initialize(history_size=100)
      @history = []
      @history_size = history_size
    end

    attr_accessor :history, :history_size

    def filter(contents)
      return true unless contents.is_a?(Vulnerability)
      return true if cve_exists?(contents.identifier)

      history_check_limit
      false
    end

    def cve_exists?(identifier)
      return true if @history.include?(identifier)

      @history << identifier
      false
    end

    def history_check_limit
      if @history.length > @history_size
        @history = @history.drop(@history.length - @history_size)
      end
    end

    def inspect
      "#<CVE::Filter history=#{@history.count} limit=#{@history_size}>"
    end
  end
end
